<template>
  <a-card :bordered='false'>
    <div class='table-page-search-wrapper' @keyup.enter='handleEnter'>
      <a-form layout='inline'>
        <a-row :gutter='48'>
          <a-col :md='6' :sm='24'>
            <a-form-item label='关键字'>
              <a-input v-model.trim='queryParam.keyword' placeholder='请输入名称/类型名称' />
            </a-form-item>
          </a-col>
          <a-col :md='6' :sm='24'>
            <a-form-item label='设备Id'>
              <a-input v-model='queryParam.sbInfoName' placeholder='设备Id' />
            </a-form-item>
          </a-col>
          <a-select
            v-model="['queryParam.type', {rules: [{required: true, message: '类型不能为空'}]}]"
            placeholder='请选择'>
            <a-select-option
              v-for='(label,value) in typeMap'
              :key='value'
              :label='label'
              :value='parseInt(value)'>{{ label }}
            </a-select-option>
          </a-select>
          <a-select
            v-model="['queryParam.status', {rules: [{required: true, message: '状态不能为空'}]}]"
            placeholder='请选择'>
            <a-select-option
              v-for='(label,value) in statusMap'
              :key='value'
              :label='label'
              :value='parseInt(value)'>{{ label }}
            </a-select-option>
          </a-select>
          <a-col :md='6 || 24' :sm='24'>
                        <span class='table-page-search-submitButtons'>
                          <a-button type='primary' @click='$refs.table.refresh(true)'>查询</a-button>
                          <a-button style='margin-left: 8px' @click='resetSearchForm'>重置</a-button>
                        </span>
          </a-col>
        </a-row>
      </a-form>
    </div>

    <div class='table-operator' style='margin-bottom: 8px;'>
      <a-row>
        <a-col :md='16'>
          <a-button v-if="$auth('sb-sb-add')" type='primary' icon='plus' @click='$refs.baseModal.base()'>新增</a-button>
          <a-button style='margin-left: 8px' v-if="$auth('sb-sb-export')" type='primary' icon='download'
                    @click='doExport'>导出
          </a-button>
          <a-dropdown v-action:edit v-if="selectedRowKeys.length > 0 && $auth('sb-sb-del')">
            <a-menu slot='overlay'>
              <a-popconfirm title='是否要删除所选数据？' @confirm='batchDelete()'>
                <a-menu-item key='1'>
                  <a-icon type='delete' />
                  <a>删除</a></a-menu-item>
              </a-popconfirm>
            </a-menu>
            <a-button style='margin-left: 8px'>
              批量操作
              <a-icon type='down' />
            </a-button>
          </a-dropdown>
        </a-col>
        <a-col style='text-align: right'>
                    <span class='table-page-search-submitButtons'>
                    <a-button type='primary' @click='handleOk'>查询</a-button>
                    <a-button style='margin-left: 8px' @click='resetSearchForm'>重置</a-button>
                    <a @click='()=>{ this.advanced = !this.advanced}' style='margin-left: 8px'>
                      {{ advanced ? '收起' : '展开' }}
                      <a-icon :type="advanced ? 'up' : 'down'" />
                    </a>
                  </span>
        </a-col>
      </a-row>
    </div>

    <s-table
      ref='table'
      size='default'
      rowKey='id'
      :columns='columns'
      :data='loadData'
      :alert='options.alert'
      :rowSelection='options.rowSelection'
      showPagination='auto'
    >
            <span slot='action' slot-scope='record'>
              <template>
                <a @click='handleView(record)'>查看</a>
                <operation-button
                  v-if="$auth('sb-sb-edit')" @click='handleEdit(record)'
                >修改</operation-button>
                <operation-button
                  v-if="$auth('sb-sb-del')"
                  :type='2'
                  title='是否要删除该条数据？'
                  @confirm='batchDelete(record.id)'>删除</operation-button>
              </template>
            </span>
    </s-table>
    <base-form ref='baseModal' @ok='handleOk' />
    <detail ref='detailModal' />
    <detail-audit-scrap :audit="false" ref="detailAuditScrapModal" @ok="handleOk"/>
  </a-card>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from './modules/BaseForm'
import Detail from './modules/Detail'
import DetailAuditScrap from '@/views/sb/scraps/modules/DetailAudit'
import {
  getSbInfoStopDetailPage,
  deleteSbInfoStopDetails,
  fetchSbInfoStopDetail,
  exportSbInfoStopDetail
} from '@/api/sb/sb-stop-details'

export default {
  name: 'SbInfoStopDetailList',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    Detail,
    DetailAuditScrap
  },
  data() {
    return {
      advanced: false,
      // 查询参数
      queryParam: {},
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          customRender: (text, record, index) => {
            return `${(this.$refs.table.localPagination.current - 1) * this.$refs.table.localPagination.pageSize + index + 1}`
          }
        },
        {
          title: '设备Id',
          dataIndex: 'sbId',
          customRender: (text, record, index) => {
            return '<a @click=="sbIdhandleDetail">' + record.sbInfo + '</a>'
          }
        },
        {
          title: '类型',
          dataIndex: 'type',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.typeMap, text)
          }
        },
        {
          title: '状态',
          dataIndex: 'status',
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.statusMap, text)
          }
        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 下拉框map
      typeMap: {},
      statusMap: {},
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          ...this.queryParam,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getSbInfoStopDetailPage(Object.assign(parameter, this.queryParam))
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: {
          show: true, clear: () => {
            this.selectedRowKeys = []
          }
        },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false
    }
  },
  created() {
    // 下拉框map
    this.typeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SB_INFO_STOP_DETAIL_)
    this.statusMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SB_INFO_STOP_DETAIL_)
    this.tableOption()
  },
  methods: {
    tableOption() {
      if (!this.optionAlertShow) {
        this.options = {
          alert: {
            show: true, clear: () => {
              this.selectedRowKeys = []
            }
          },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    batchDelete(id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteSbInfoStopDetails(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleEdit(record) {
      fetchSbInfoStopDetail({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleView(record) {
      fetchSbInfoStopDetail({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk() {
      this.$refs.table.refresh()
    },
    onSelectChange(selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm() {
      this.queryParam = {}
      this.$refs.table.refresh(true)
    },
    doExport() {
      const parameter = {
        ...this.queryParam
      }
      exportSbInfoStopDetail(parameter).then(file => {
        this.BaseTool.Util.downLoadExportExcel(file)
      })
    },
    handleEnter() {
      this.$refs.table.refresh(true)
    }
    ,
    sbIdhandleDetail() {
      const text = this.$router.resolve({
        name: sbInfo,
        query: { id: this.model.sbId }
      })
      // 打开一个新的页面
      window.open(text.href, '_blank')
    }
  }
}
</script>
